/*
    (C) 2000 AROS - The Amiga Research OS
    $Id: relabel.c,v 1.1.1.1 2005/03/15 16:00:59 laire Exp $
 
    Desc: 
    Lang: English
*/

/******************************************************************************
 
 
    NAME
 
        Relabel
 
    SYNOPSIS
 
        DRIVE/A, NAME/A
 
    LOCATION
 
        Workbench:C
 
    FUNCTION
 
        Rename a volume
 
    INPUTS
 
        DRIVE   --  The volume to rename
	NAME    --  The new name
 
    RESULT
 
    NOTES
 
    EXAMPLE
 
    BUGS
 
    SEE ALSO
 
    INTERNALS
 
    HISTORY
 
    01.05.2000  SDuvan  implemented
 
******************************************************************************/

#include <exec/memory.h>

#include <dos/dos.h>
#include <dos/dosextens.h>
#include <dos/exall.h>
#include <dos/rdargs.h>
#include <dos/stdio.h>

#include <proto/dos.h>
#include <proto/exec.h>

#include <string.h>

#include "relabel_version.h"

static const char version[] = VERSTAG;

enum { ARG_DRIVE = 0, ARG_NAME };

int main(void)
{
	struct Library *SysBase=*((struct Library**) 4);
	struct DosLibrary	*DOSBase;
	int  retval = RETURN_FAIL;
	STRPTR args[2];
	struct RDArgs *rda;

	if ((DOSBase=(struct DosLibrary *)OpenLibrary("dos.library",37)))
	{
		/* both /A args, no need to clr args */
		rda = ReadArgs("DRIVE/A,NAME/A", (LONG *) args, NULL);

		if (rda)
		{
			if (!strchr(args[ARG_NAME], ':'))
			{
				ULONG len = strlen(args[ARG_DRIVE]);
				UBYTE tmp[len + 1];
				struct DosList *dl;

				if (!len || args[ARG_DRIVE][len - 1] != ':')
					goto invalid;

				len--;
				memcpy(tmp, args[ARG_DRIVE], len);
				tmp[len] = '\0';

				dl = LockDosList(LDF_READ | LDF_DEVICES | LDF_VOLUMES);
				dl = FindDosEntry(dl, tmp, LDF_DEVICES | LDF_VOLUMES);
				UnLockDosList(LDF_READ | LDF_DEVICES | LDF_VOLUMES);

				if (dl)
				{
					if (Relabel(args[ARG_DRIVE], args[ARG_NAME]))
					{
						retval = RETURN_OK;
					}
					else
					{
						PrintFault(IoErr(), NULL);
					}
				}
				else
				{
					invalid:
					PutStr("Invalid device or volume name\n");
				}
			}
			else
			{
				PutStr("':' not legal character in volume name\n");
			}

			FreeArgs(rda);
		}
		else
		{
			PrintFault(IoErr(), NULL);
		}

		CloseLibrary((struct Library *)DOSBase);
	}

	return retval;
}
